"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const file_exists_1 = __importDefault(require("file-exists"));
const SRC_PATH = (_a = process.env.SRC_PATH) !== null && _a !== void 0 ? _a : '.';
function resolve(name, full, throwError = false) {
    if (full) {
        if (file_exists_1.default.sync(path_1.default.join(process.cwd(), full))) {
            return path_1.default.resolve(path_1.default.join(process.cwd(), full));
        }
        if (file_exists_1.default.sync(path_1.default.join(full))) {
            return path_1.default.resolve(path_1.default.join(full));
        }
        if (throwError) {
            throw new Error(`Unable to resolve ${path_1.default.join(process.cwd(), full)}`);
        }
    }
    if (file_exists_1.default.sync(path_1.default.join(process.cwd(), SRC_PATH, name))) {
        return path_1.default.resolve(path_1.default.join(process.cwd(), SRC_PATH, name));
    }
    if (file_exists_1.default.sync(path_1.default.join(process.cwd(), name))) {
        return path_1.default.resolve(path_1.default.join(process.cwd(), name));
    }
    if (fs_1.default.existsSync(path_1.default.join(process.cwd(), 'node_modules', name))) {
        return path_1.default.join(process.cwd(), 'node_modules', name);
    }
    try {
        return require.resolve(name);
    }
    catch (_a) {
        return null;
    }
}
exports.default = resolve;
